## rtpmidid-2022-07-07.tar.gz

=== CMakeLists.txt ===
project(rtpmidid)
cmake_minimum_required(VERSION 3.2)
add_definitions("-std=gnu++17 -Wall -Werror")
# set(CMAKE_POSITION_INDEPENDENT_CODE ON)

set (CMAKE_CXX_FLAGS_DEBUG "${CMAKE_CXX_FLAGS_DEBUG} -fno-omit-frame-pointer -fstack-protector-strong")
set (CMAKE_LINKER_FLAGS_DEBUG "${CMAKE_LINKER_FLAGS_DEBUG} -fno-omit-frame-pointer")


include(FindPkgConfig)
pkg_check_modules(AVAHI REQUIRED avahi-client)
pkg_check_modules(FMT REQUIRED fmt)
pkg_check_modules(ALSA REQUIRED alsa)


include_directories(${CMAKE_SOURCE_DIR}/src ${CMAKE_SOURCE_DIR}/include)
enable_testing()

execute_process(
  COMMAND bash -c "git describe --match \"v[0-9]*\" --tags --abbrev=5 HEAD | sed 's/^v//g' | sed 's/-/~/g' | tr -d '\n'"
  OUTPUT_VARIABLE RTPMIDID_VERSION
)
add_definitions(-DRTPMIDID_VERSION=\"${RTPMIDID_VERSION}\")
message(STATUS "Version ${RTPMIDID_VERSION}")

add_subdirectory(lib)
add_subdirectory(src)
add_subdirectory(tests)

=== Makefile ===
PORT := 10000

.PHONY: help
help:
	@echo "Makefile for rtpmidid"
	@echo
	@echo " build   -- Creates the build directory and builds the rtpmidid"
	@echo " run     -- builds and runs the daemon"
	@echo " setup   -- Creates the socket control file"
	@echo " clean   -- Cleans project"
	@echo " deb     -- Generate deb package"
	@echo " test    -- Runs all test"
	@echo " install -- Installs to PREFIX or DESTDIR (default /usr/local/)"
	@echo " man     -- Generate man pages"
	@echo
	@echo " gdb     -- Run inside gdb, to capture backtrace of failures (bt). Useful for bug reports."
	@echo " capture -- Capture packets with tcpdump. Add this to bug reports."
	@echo
	@echo "Variables:"
	@echo 
	@echo " PORT=10000"
	@echo 

.PHONY: build
build: build/bin/rtpmidid

build/bin/rtpmidid: src/* tests/* CMakeLists.txt
	mkdir -p build
	cd build &&	cmake .. -DCMAKE_BUILD_TYPE=Release
	cd build && make -j

build-dev: 
	mkdir -p build
	cd build &&	cmake .. -DCMAKE_BUILD_TYPE=Debug
	cd build && make -j


man: 
	mkdir -p build/man/
	pandoc rtpmidid.1.md -s -t man -o build/man/rtpmidid.1
	pandoc rtpmidid-cli.1.md -s -t man -o build/man/rtpmidid-cli.1

.PHONY: clean
clean:
	rm -rf build

VALGRINDFLAGS := --leak-check=full --error-exitcode=1
RTPMIDID_ARGS := --port ${PORT} --name devel

.PHONY: run run-valgrind gdb
run: build
	build/src/rtpmidid $(RTPMIDID_ARGS)

gdb: build-dev
	gdb build/src/rtpmidid -ex=r --args build/src/rtpmidid  $(RTPMIDID_ARGS)

run-valgrind: build
	valgrind --leak-check=full --show-leak-kinds=all build/src/rtpmidid $(RTPMIDID_ARGS)

PORT1 = $(shell echo | awk '{print ${PORT} + 1}')

.PHONY: dump
capture:
	rm -f /tmp/rtpmidid-${PORT}.dump
	@echo "\033[1;32m"
	@echo
	@echo "   Captured data will be at /tmp/rtpmidid-${PORT}.dump"
	@echo
	@echo "   Press Control-C to stop capturing.  "
	@echo "\033[0m"
	@echo
	tcpdump -i any '(udp port ${PORT}) or (udp port ${PORT1})' -v -w /tmp/rtpmidid-${PORT}.dump

.PHONY: setup
setup:
	sudo mkdir -p /var/run/rtpmidid
	sudo chown $(shell whoami) /var/run/rtpmidid

.PHONY: test test_mdns test_rtppeer test_rtpserver
test: test_rtppeer test_rtpserver

test_rtppeer: build
	valgrind $(VALGRINDFLAGS) build/tests/test_rtppeer

test_rtpserver: build
	valgrind $(VALGRINDFLAGS) build/tests/test_rtpserver

.PHONY: deb
deb:
	$(eval VERSION := $(shell git describe --match "v[0-9]*" --tags --abbrev=5 HEAD | sed 's/^v//g' | sed 's/-/~/g' ))
	$(eval DATE := $(shell date -R))
	sed -i "1s/.*/rtpmidid (${VERSION}) unstable; urgency=medium/" debian/changelog
	sed -i "5s/.*/ -- David Moreno <dmoreno@coralbits.com>  ${DATE}/" debian/changelog

	dpkg-buildpackage --no-sign

ifneq ($(DESTDIR),)
    PREFIX := $(DESTDIR)
endif
ifeq ($(PREFIX),)
    PREFIX := /usr/local/
endif
.PHONY: install

install: install-rtpmidid install-librtpmidid0 install-librtpmidid0-dev

install-rtpmidid: build man
	mkdir -p $(PREFIX)/usr/bin/ 
	cp build/src/rtpmidid $(PREFIX)/usr/bin/
	cp cli/rtpmidid-cli.py $(PREFIX)/usr/bin/rtpmidid-cli
	mkdir -p $(PREFIX)/etc/systemd/system/
	cp debian/rtpmidid.service $(PREFIX)/etc/systemd/system/
	mkdir -p $(PREFIX)/usr/share/doc/rtpmidid/
	cp README.md $(PREFIX)/usr/share/doc/rtpmidid/
	cp LICENSE-daemon.txt $(PREFIX)/usr/share/doc/rtpmidid/LICENSE.txt
	mkdir -p $(PREFIX)/usr/share/man/man1/
	cp build/man/rtpmidid.1 $(PREFIX)/usr/share/man/man1/
	cp build/man/rtpmidid-cli.1 $(PREFIX)/usr/share/man/man1/

install-librtpmidid0: build
	mkdir -p $(PREFIX)/usr/lib/ 
	cp -a build/lib/lib*so* $(PREFIX)/usr/lib/
	mkdir -p $(PREFIX)/usr/share/doc/librtpmidid0/
	cp README.md $(PREFIX)/usr/share/doc/librtpmidid0/
	cp README.librtpmidid.md $(PREFIX)/usr/share/doc/librtpmidid0/
	cp LICENSE-lib.txt $(PREFIX)/usr/share/doc/librtpmidid0/LICENSE.txt

install-librtpmidid0-dev: build
	mkdir -p $(PREFIX)/usr/lib/ $(PREFIX)/usr/include/
	cp -a build/lib/lib*.a $(PREFIX)/usr/lib/
	cp -a include/rtpmidid $(PREFIX)/usr/include/
	mkdir -p $(PREFIX)/usr/share/doc/librtpmidid0-dev/
	cp README.md $(PREFIX)/usr/share/doc/librtpmidid0-dev/
	cp README.librtpmidid.md $(PREFIX)/usr/share/doc/librtpmidid0-dev/
	cp LICENSE-lib.txt $(PREFIX)/usr/share/doc/librtpmidid0-dev/LICENSE.txt

=== lib/CMakeLists.txt ===
add_library(
  rtpmidid-shared
  SHARED
  rtppeer.cpp rtpclient.cpp rtpserver.cpp
  mdns_rtpmidi.cpp logger.cpp poller.cpp
  utils.cpp
)

add_library(
  rtpmidid-static
  STATIC
  rtppeer.cpp rtpclient.cpp rtpserver.cpp
  mdns_rtpmidi.cpp logger.cpp poller.cpp
  utils.cpp
)

include(FindPkgConfig)

pkg_check_modules(AVAHI REQUIRED avahi-client)

target_link_libraries(rtpmidid-static ${AVAHI_LIBRARIES})
target_include_directories(rtpmidid-static PUBLIC ${AVAHI_INCLUDE_DIRS})
target_compile_options(rtpmidid-static PUBLIC ${AVAHI_CFLAGS_OTHER})

target_link_libraries(rtpmidid-shared ${AVAHI_LIBRARIES})
target_include_directories(rtpmidid-shared PUBLIC ${AVAHI_INCLUDE_DIRS})
target_compile_options(rtpmidid-shared PUBLIC ${AVAHI_CFLAGS_OTHER})

set_target_properties(rtpmidid-static PROPERTIES OUTPUT_NAME rtpmididstatic)
set_target_properties(rtpmidid-shared PROPERTIES OUTPUT_NAME rtpmidid)

set_target_properties(rtpmidid-shared rtpmidid-static
	PROPERTIES
		SOVERSION 0
		VERSION 21.07
	)

=== src/CMakeLists.txt ===
add_executable(
  rtpmidid-daemon  
  aseq.cpp stringpp.cpp
  main.cpp config.cpp rtpmidid.cpp
  control_socket.cpp
)

target_link_libraries(rtpmidid-daemon ${AVAHI_LIBRARIES})
target_include_directories(rtpmidid-daemon PUBLIC ${AVAHI_INCLUDE_DIRS})
target_compile_options(rtpmidid-daemon PUBLIC ${AVAHI_CFLAGS_OTHER})

target_link_libraries(rtpmidid-daemon ${FMT_LIBRARIES})
target_include_directories(rtpmidid-daemon PUBLIC ${FMT_INCLUDE_DIRS})
target_compile_options(rtpmidid-daemon PUBLIC ${FMT_CFLAGS_OTHER})

target_link_libraries(rtpmidid-daemon ${ALSA_LIBRARIES})
target_include_directories(rtpmidid-daemon PUBLIC ${ALSA_INCLUDE_DIRS})
target_compile_options(rtpmidid-daemon PUBLIC ${ALSA_CFLAGS_OTHER})

target_link_libraries(rtpmidid-daemon rtpmidid-static)

set_target_properties(rtpmidid-daemon PROPERTIES OUTPUT_NAME rtpmidid)

=== tests/CMakeLists.txt ===
add_executable(test_rtppeer test_rtppeer.cpp test_utils.cpp)
target_link_libraries(test_rtppeer rtpmidid-shared -lfmt)
add_test(NAME test_rtppeer COMMAND test_rtppeer)

add_executable(test_rtpserver test_rtpserver.cpp test_utils.cpp)
target_link_libraries(test_rtpserver rtpmidid-shared -lfmt -pthread)
add_test(NAME test_rtpserver COMMAND test_rtpserver)

add_executable(test_poller test_poller.cpp test_utils.cpp)
target_link_libraries(test_poller rtpmidid-shared -lfmt -pthread)
add_test(NAME test_poller COMMAND test_poller)


add_executable(test_misc test_misc.cpp test_utils.cpp)
target_link_libraries(test_misc rtpmidid-shared -lfmt -pthread)
add_test(NAME test_misc COMMAND test_poller)

add_executable(test_rtpmidid 
    test_rtpmidid.cpp test_utils.cpp 
    ../src/aseq.cpp  ../src/config.cpp ../src/control_socket.cpp ../src/rtpmidid.cpp ../src/stringpp.cpp
)
target_link_libraries(test_rtpmidid rtpmidid-shared -lfmt -pthread)

target_link_libraries(test_rtpmidid ${AVAHI_LIBRARIES})
target_include_directories(test_rtpmidid PUBLIC ${AVAHI_INCLUDE_DIRS})
target_compile_options(test_rtpmidid PUBLIC ${AVAHI_CFLAGS_OTHER})

target_link_libraries(test_rtpmidid ${FMT_LIBRARIES})
target_include_directories(test_rtpmidid PUBLIC ${FMT_INCLUDE_DIRS})
target_compile_options(test_rtpmidid PUBLIC ${FMT_CFLAGS_OTHER})

target_link_libraries(test_rtpmidid ${ALSA_LIBRARIES})
target_include_directories(test_rtpmidid PUBLIC ${ALSA_INCLUDE_DIRS})
target_compile_options(test_rtpmidid PUBLIC ${ALSA_CFLAGS_OTHER})

# disabled as failing 
# add_test(NAME test_rtpmidid COMMAND test_rtpmidid)

=== debian/changelog ===
rtpmidid (21.11) unstable; urgency=medium

  * Several MIDI packets in a single packet. This solves several issues 
    with third party implementations.
  * Resassembly of SysEx packages
  * Internal improvements
  * More tests
  * Log colors only on terminals
  * Parsing or Real Time Events
  * Moved mdns_rtpmidi into the library

 -- David Moreno <dmoreno@coralbits.com>  Thu, 04 Nov 2021 21:52:52 +0100

rtpmidid (21.07) unstable; urgency=medium

  * Bugfix: bad ordering of events 
  * More MIDI events
  * Bad acess initiator / ssrc
  * Bigger buffer size for sysex

 -- David Moreno <dmoreno@coralbits.com>  Fri, 23 Jul 2021 19:42:45 +0200

rtpmidid (20.07) unstable; urgency=medium

  * Improved Mac OS and iOS support
  * Control CLI
  * LGPL2.1 Library
  * Improved stability

 -- David Moreno <dmoreno@coralbits.com>  Sat, 11 Jul 2020 13:01:46 +0200

rtpmidid (20.04.5) unstable; urgency=medium

  * Initial Release.

 -- David Moreno <dmoreno@coralbits.com>  Sun, 05 Apr 2020 15:36:37 +0200

=== debian/control ===
Source: rtpmidid
Section: unknown
Priority: optional
Maintainer: David Moreno <dmoreno@coralbits.com>
Build-Depends: debhelper (>= 10), libavahi-client-dev, libfmt-dev, libasound2-dev, python3, cmake, pandoc
Standards-Version: 4.1.2
Homepage: https://github.com/davidmoreno/rtpmidid

Package: rtpmidid
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, python3
Description: Real Time Protocol Musical Instrument Digital Interface Daemon (RTP-MIDI)
 rtpmidid allows you to share ALSA sequencer devices on the network using RTP
 MIDI, and import other network shared RTP MIDI devices.
 .
 rtpmidid is an user daemon, and when a RTP MIDI device is announced using mDNS
 (also known as Zeroconf, Avahi, and multicast DNS) it exposes this ALSA
 sequencer port.

Package: librtpmidid0
Section: libs
Architecture: any
Description: RTP MIDI library

Package: librtpmidid0-dev
Section: libdevel
Architecture: any
Depends: libfmt-dev, librtpmidid0
Description: RTP MIDI library development files

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.
export DH_VERBOSE = 1

# see FEATURE AREAS in dpkg-buildflags(1)
#export DEB_BUILD_MAINT_OPTIONS = hardening=+all

# see ENVIRONMENT in dpkg-buildflags(1)
# package maintainers to append CFLAGS
#export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
# package maintainers to append LDFLAGS
#export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@


build:
	make build

install:
	make install-rtpmidid PREFIX=debian/rtpmidid/
	make install-librtpmidid0 PREFIX=debian/librtpmidid0/
	make install-librtpmidid0-dev PREFIX=debian/librtpmidid0-dev/

# dh_make generated override targets
# This is example for Cmake (See https://bugs.debian.org/641051 )
#override_dh_auto_configure:
#	dh_auto_configure -- #	-DCMAKE_LIBRARY_PATH=$(DEB_HOST_MULTIARCH)
